/*

Starfield Lib example...

Coded by Jeff Lawton (aka Zark Wizard)
Group Nemesis   - May 29 - 1998

Visit our home site at : http://yaroze-world.org

*/

#include <libps.h>
#include "pad.h"
#include "starslib.h"

#define SCREEN_WIDTH      512      
#define SCREEN_HEIGHT     240      
#define SCREEN_X_OFFSET     0
#define SCREEN_Y_OFFSET    16

#define SPRITE_CNT 500
#define OT_LEN 1

GsOT		WorldOT[SPRITE_CNT];
GsOT_TAG	OTTags[SPRITE_CNT][1<<OT_LEN];
int		abuff;
PACKET	PA[2][SPRITE_CNT*sizeof(GsSPRITE)];
GsSPRITE	oursprite;
u_char  *Nemlogo;

// Variable declarations

volatile u_char *bb0, *bb1;

//  Routines that are defined:

static u_long PadRead();

int main(void)
{

  int     nobj = 1; 
  int     i, cnt; 

  SetVideoMode(MODE_NTSC); // Replace this with MODE_PAL if necessary

  GsInitGraph(SCREEN_WIDTH, SCREEN_HEIGHT, 4, 0, 0);

  GsDefDispBuff(0, 0, 0, 240);

  GetPadBuf(&bb0, &bb1);

// Get the program to build the star field...  
// I want 200 stars, moving down the screen
// x1, y1 (Upper left corner of box)
// height, width  (of box)

  star_field(200, STAR_R, 50, 50, 200, 400);

  ResetGraph(0);

  for (i=0;i<SPRITE_CNT;i++)
  {
    	WorldOT[i].length=OT_LEN;
    	WorldOT[i].org=OTTags[i];
  }

  
  do { 
    abuff=GsGetActiveBuff();
    GsSetWorkBase((PACKET *)PA[abuff]);
    GsClearOt(0,0,&WorldOT[abuff]);

// Call the animate routine during each display loop.

// normally in our code we always have a global pointer to the 
// ordering table.  For the example I have added one to the starslib.
// You could adjust it so it points to your current OT.  If you're kind
// of lost let me know and I'll see what I can do to help.
    TheOT = &WorldOT[abuff];

    ani_stars();

    DrawSync(0);             

    cnt=VSync(0);          

    printf("%d ", cnt);

    GsSwapDispBuff();        
    GsSortClear(0,0,0,&WorldOT[abuff]);
    GsDrawOt(&WorldOT[abuff]);	

    nobj = PadRead();

  } while ( !(nobj & dPADselect) );

        
  return(0);
}

u_long PadRead(void)
{
	return(~(*(bb0+3) | *(bb0+2) << 8 | *(bb1+3) << 16 | *(bb1+2) << 24));
}
